#region usings
using System;
using System.ComponentModel.Composition;

using VVVV.PluginInterfaces.V1;
using VVVV.PluginInterfaces.V2;
using VVVV.Utils.VColor;
using VVVV.Utils.VMath;

using VVVV.Core.Logging;
#endregion usings



namespace VVVV.Nodes
{
	
	#region PluginInfo
	[PluginInfo(Name = "AsValue", Category = "String", Version = "Interim", Help = "Tries to convert incoming strings to doubles", Tags = "", Author = "bjo:rn")]
	#endregion PluginInfo
	public class InterimStringAsValueNode : IPluginEvaluate
	{
		#region fields & pins
		[Input("Input", DefaultString = "1.0" )]
		IDiffSpread<String> FInput;

		[Output("Output")]
		ISpread<double> FOutput;

		[Import()]
		ILogger FLogger;
		#endregion fields & pins

		//called when data for any output pin is requested
		public void Evaluate(int SpreadMax)
		{
			FOutput.SliceCount = SpreadMax;

			if (FInput.IsChanged) 
			{
				for (int i = 0; i < SpreadMax; i++)
					FOutput[i] = ToDouble(FInput[i]);	
			}
		}
		
		public static double ToDouble(string In)
		{		
    		double dblOut;
			double dblDefault = 0.00;

    		try
    		{
        		dblOut = Convert.ToDouble(In.Replace(".", ","));
    		}
    		catch
    		{
        		dblOut = dblDefault;
    		}

    		return dblOut;
		}
		
	}
}
